<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:redirect="com.scenari.xsldom.xalan.lib.Redirect" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" extension-element-prefixes="redirect" exclude-result-prefixes="sc xhtml" version="1.0">
	<xsl:output omit-xml-declaration="yes" indent="no" method="xml"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:template match="treeContent">
		<xsl:if test="count(descendant::entry) &gt; 1">
			<hr class="hidden"/>
			<strong class="hidden">Navigation :</strong>
			<ul>
				<xsl:attribute name="class">
					<xsl:value-of select="concat('mnu_static mnu_root outMnu_sub ','outMnu', si(count(entry)=2 and entry/root='webSite',' outMnuOneRoot'))"/>
				</xsl:attribute>
				<xsl:apply-templates/>
			</ul>
		</xsl:if>
	</xsl:template>
	<xsl:template match="entry">
		<xsl:variable name="vClass" select="resultatDialogue(concat(@dialog, '/outlineClasses'))"/>
		<xsl:variable name="vUrl" select="resultatDialogue(string(@dialog), 'act:')"/>
		<xsl:variable name="vType" select="returnFirst(root,'ext')"/>
		<xsl:variable name="vDepth" select="count(ancestor::entry)"/>
		<xsl:variable name="vTi" select="si($vType='ext','external links')"/>
		<xsl:variable name="vClasses" select="concat('outMnu_sel_',si(@position = 'current', 'yes', 'no'),' outMnu_typ_',$vType,' outMnu_',si(entry,'b','l'),' outMnu_dpt_',$vDepth,' ',$vClass)"/>
		<xsl:if test="not(contains(@dialog,'outJson'))">
			<li class="{$vClasses}">
				<xsl:variable name="vSubUrl" select="resultatDialogue(string(entry[1]/@dialog), 'act:')"/>
				<div class="outMnuLbl {$ vClasses}{si(entry and not(descendant::entry/@position='current' or @position='current'),' outMnu_b_c','')}" id="{$vUrl}">
					<xsl:choose>
						<xsl:when test="@position = 'current' or (@position = 'parent' or @position = 'ancestor') and $vSubUrl = $vUrl">
							<span class="outMnu_i" title="{$vTi}">
								<span class="outMnu_ti">
									<xsl:value-of select="@title"/>
								</span>
							</span>
						</xsl:when>
						<xsl:otherwise>
							<a href="{$vUrl}" target="_self" class="outMnu_i outMnu_lnk" title="{$vTi}">
								<span class="outMnu_ti">
									<xsl:value-of select="@title"/>
								</span>
							</a>
						</xsl:otherwise>
					</xsl:choose>
				</div>
				<xsl:if test="entry and (descendant::entry/@position='current' or @position='current')">
					<ul class="outMnu_sub">
						<xsl:apply-templates/>
					</ul>
				</xsl:if>
			</li>
		</xsl:if>
	</xsl:template>
	<xsl:template match="node()"/>
</xsl:stylesheet>