<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:redirect="com.scenari.xsldom.xalan.lib.Redirect" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" extension-element-prefixes="redirect" exclude-result-prefixes="sc xhtml" version="1.0">
	<xsl:output omit-xml-declaration="yes" indent="no" method="xml"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:variable name="vMaxChar" select="number(getGeneratorProperty('optim.menu.cat.maxChar', '123'))"/>
	<xsl:variable name="vTitleText">
		<xsl:for-each select="//treeContent/entry">
			<xsl:value-of select="@title"/>
		</xsl:for-each>
	</xsl:variable>
	<xsl:variable name="vNumChar" select="string-length($vTitleText) + count(//treeContent/entry)*2"/>
	<xsl:variable name="vTruncateTitles" select="$vNumChar &gt; $vMaxChar"/>
	<xsl:variable name="vNumCat" select="count(//treeContent/entry)"/>
	<xsl:variable name="vMaxCharPerCat" select="max(12, round($vMaxChar div $vNumCat)-3)"/>
	<xsl:template match="treeContent">
		<xsl:if test="count(entry) &gt; 1">
			<strong class="hidden">General navigation:</strong>
			<ul class="outCat">
				<xsl:apply-templates/>
			</ul>
			<hr class="hidden"/>
		</xsl:if>
	</xsl:template>
	<xsl:template match="entry">
		<xsl:variable name="vClass" select="resultatDialogue(concat(@dialog, '/outlineClasses'))"/>
		<xsl:variable name="vUrl" select="resultatDialogue(string(@dialog), 'act:')"/>
		<xsl:variable name="vType" select="returnFirst(root,'ext')"/>
		<xsl:variable name="vTruncateTitle" select="$vTruncateTitles and string-length(@title) &gt; $vMaxCharPerCat"/>
		<xsl:variable name="vLbl" select="si($vTruncateTitle, concat(substring(@title,1,$vMaxCharPerCat),'…'), @title)"/>
		<xsl:variable name="vTi" select="si($vTruncateTitle,concat(@title,si($vType='ext',' - ')), si($vType='ext','external links'))"/>
		<xsl:variable name="vIsSel" select="containWord('current parent ancestor',@position)"/>
		<xsl:variable name="vIsLnk" select="containWord('sibling uncle cousin',@position) or containWord('parent ancestor',@position) and containWord('blog',$vType)"/>
		<li class="outCat_sel_{si($vIsSel, 'yes', 'no')} outCat_typ_{$vType} outCat_{si(entry,'b','l')} {$vClass}">
			<xsl:choose>
				<xsl:when test="$vIsLnk">
					<a href="{$vUrl}" target="_self" class="outCat_i outCat_lnk" title="{$vTi}">
						<span>
							<xsl:value-of select="$vLbl"/>
						</span>
					</a>
				</xsl:when>
				<xsl:otherwise>
					<span class="outCat_i" title="{$vTi}">
						<span>
							<xsl:value-of select="$vLbl"/>
						</span>
					</span>
				</xsl:otherwise>
			</xsl:choose>
		</li>
	</xsl:template>
	<xsl:template match="node()"/>
</xsl:stylesheet>