<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xslt/java" exclude-result-prefixes="sc sp java">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:template match="*">
		<xsl:for-each select="descendant::sc:uLink[@url]">
			<xsl:if test="not(contains(string(@url), '@')) and setEntryBuffer('ctrlUrl',concat(java:getSrcUri(srcFileAgent()), string(@url)))">
				<urlCtrlLnk url="{string(@url)}" refItem="{java:getSrcUri(srcFileAgent())}" refUri="{srcFields(resolveSrcPath(java:getSrcUri(srcFileAgent())), 'srcUri')}"/>
			</xsl:if>
		</xsl:for-each>
		<xsl:for-each select="descendant::sc:extBlock[@role='img']">
			<xsl:value-of select="getContent(gotoSubModel(),'ctrlUrl')" disable-output-escaping="yes"/>
		</xsl:for-each>
		<xsl:for-each select="descendant::sc:extBlock[@role='anim']">
			<xsl:value-of select="getContent(gotoSubModel(),'ctrlUrl')" disable-output-escaping="yes"/>
		</xsl:for-each>
		<xsl:for-each select="descendant::sc:uLink[@role='def']">
			<xsl:value-of select="getContent(gotoSubModel(),'ctrlUrl')" disable-output-escaping="yes"/>
		</xsl:for-each>
		<xsl:for-each select="descendant::sc:uLink[@role='doc']">
			<xsl:value-of select="getContent(gotoSubModel(),'ctrlUrl')" disable-output-escaping="yes"/>
		</xsl:for-each>
		<xsl:for-each select="descendant::sc:uLink[@role='ref']">
			<xsl:value-of select="getContent(gotoSubModel(),'ctrlUrl')" disable-output-escaping="yes"/>
		</xsl:for-each>
		<xsl:for-each select="descendant::sc:inlineImg[@role='ico']">
			<xsl:value-of select="getContent(gotoSubModel(),'ctrlUrl')" disable-output-escaping="yes"/>
		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>