<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:of="scpf.org:office" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:java="http://xml.apache.org/xslt/java" xmlns="http://www.utc.fr/ics/scenari/v3/primitive" exclude-result-prefixes="of sp java " >

<xsl:param name="srcNode"/>

<xsl:template match="text()|@*"/>
<xsl:template match="*[@sc:refUri]">
<attrRef nm="?" refUri="{@sc:refUri}"/>
</xsl:template>

<xsl:template match="/sc:item">
<xsl:apply-templates select="of:webSitePlus"/>
</xsl:template>

<xsl:template match="sc:item/of:webSitePlus">
	<title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="of:webSitePlusM"><xsl:value-of select="sp:title"/></xsl:for-each></title>
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>



			
				
				
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:webSitePlus/sp:home[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:margin' or name()='sp:home')]">
<cPbs><pb msg="An item was referenced more than once!" typ="Error">
<xsl:value-of select="formatStr('Please delete one reference to the %s item .', string(@sc:refUri))"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="of_webSitePlus:home" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:webSitePlus/sp:page[@sc:refUri]">
<attrRef nm="of_webSitePlus:page" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
			
				
				
				
			
		
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:page/sp:main[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:main' or name()='sp:margin' or name()='sp:subPage')]">
<cPbs><pb msg="An item was referenced more than once!" typ="Error">
<xsl:value-of select="formatStr('Please delete one reference to the %s item .', string(@sc:refUri))"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="of_page:main" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
			
				
				
			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:page/sp:subPage[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:main' or name()='sp:margin' or name()='sp:subPage')]">
<cPbs><pb msg="An item was referenced more than once!" typ="Error">
<xsl:value-of select="formatStr('Please delete one reference to the %s item .', string(@sc:refUri))"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="of_page:subPage" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
			
		
			
		
			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:section/sp:sec[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:sec' or name()='sp:subSec')]">
<cPbs><pb msg="An item was referenced more than once!" typ="Error">
<xsl:value-of select="formatStr('Please delete one reference to the %s item .', string(@sc:refUri))"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="of_section:sec" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
		
			
		
			
			
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:fragment/sp:evtList[@sc:refUri]">
<attrRef nm="of_fragment:evtList" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:fragment/sp:gallery[@sc:refUri]">
<attrRef nm="of_fragment:gallery" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:fragment/sp:frag[@sc:refUri]">
<attrRef nm="of_fragment:frag" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
		
			
		
			
		
		
			
			
				
			
			
				
			
			
				
				
				
				
				
				
				
				
				
			
			
				
				
				
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:extBlock[@role='img'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef nm="of_txt:extBlockTag:img" refUri="{@sc:refUri}"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:extBlock[@role='anim'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef nm="of_txt:extBlockTag:anim" refUri="{@sc:refUri}"/>
</xsl:template>
		
		
			
				
			
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='def'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef nm="of_txt:uLinkTag:def" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
			
			
				
			
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='ref'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef nm="of_txt:uLinkTag:ref" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
			
			
			
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='ico'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:txt]">
<attrRef nm="of_txt:inlineImgTag:ico" refUri="{@sc:refUri}"/>
</xsl:template>
		
	<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:txt">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:blockM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:filter">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
				
				
				
			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:eventList/sp:event[@sc:refUri]">
<attrRef nm="of_eventList:event" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
			
			
		
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:eventM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:eventListM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
			
				
				
			
		
			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:gallery/sp:img[@sc:refUri]">
<attrRef nm="of_gallery:img" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
			
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:galleryM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:sectionM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:marginBlock/sp:co[@sc:refUri]">
<attrRef nm="of_marginBlock:co" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:pageM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:interactPageM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
				
				
				
				
				
			
		
			
			
				
				
				
				
				
			
		
			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:sectionPlus/sp:sec[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:sec')]">
<cPbs><pb msg="An item was referenced more than once!" typ="Error">
<xsl:value-of select="formatStr('Please delete one reference to the %s item .', string(@sc:refUri))"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="of_sectionPlus:sec" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
		
			
		
			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:tree/sp:node[@sc:refUri]">
<attrRef nm="of_tree:node" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:treeM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:treeM/sp:ico[@sc:refUri]">
<attrRef nm="of_treeM:ico:" refUri="{@sc:refUri}"/>
</xsl:template>
		
			
		
			
				
				
				
				
				
				
				
					
					
					
				
				
					
					
					
				
				
					
					
					
					
				
				
					
					
					
					
					
					
					
					
					
					
				
				
					
					
					
					
					
					
					
					
				
				
					
					
					
					
					
					
					
					
					
					
				
			
		
			
			
		
			
		
			
		
		
			
			
				
			
			
				
			
		
		
			
				
			
			
			
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='ico'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::of:sTxt]">
<attrRef nm="of_sTxt:inlineImgTag:ico" refUri="{@sc:refUri}"/>
</xsl:template>
		
	<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:sTxt">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>

			
				
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:lineM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
		
			
		
			
		
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:languageData">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
			
			
		
			
		
			
		
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:interviewPart/sp:audio[@sc:refUri]">
<attrRef nm="of_interviewPart:audio" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:head">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
			
		
			
			
		
			
			
		
			
			
		
			
		
			
				
			
			
				
					
					
					
				
			
		
			
			
		
			
			
		
			
			
		
			
			
		
			
			
		
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:head/sp:photo[@sc:refUri]">
<attrRef nm="of_head:photo:" refUri="{@sc:refUri}"/>
</xsl:template>
		
			
				
				
			
			
			
			
			
			
			
			
		
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:sectionPlusM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:pagePlus/sp:main[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:main' or name()='sp:margin' or name()='sp:subPage')]">
<cPbs><pb msg="An item was referenced more than once!" typ="Error">
<xsl:value-of select="formatStr('Please delete one reference to the %s item .', string(@sc:refUri))"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="of_pagePlus:main" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
			
				
				
			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:pagePlus/sp:subPage[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:main' or name()='sp:margin' or name()='sp:subPage')]">
<cPbs><pb msg="An item was referenced more than once!" typ="Error">
<xsl:value-of select="formatStr('Please delete one reference to the %s item .', string(@sc:refUri))"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="of_pagePlus:subPage" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
			
				
				
				
			
		
			
		
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:urlPageM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:pagePlusM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:blog/sp:presentation[@sc:refUri]">
<attrRef nm="of_blog:presentation" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
			
				
				
			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:blog/sp:post[@sc:refUri]">
<attrRef nm="of_blog:post" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
		
			
		
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:post/sp:sec[@sc:refUri]">
<attrRef nm="of_post:sec" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:postM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
			
		
			
		
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:postM/sp:tags/sp:tag[@sc:refUri]">
<attrRef nm="of_postM:tags:tag:" refUri="{@sc:refUri}"/>
</xsl:template>
			
		
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:blogM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
			
		
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:webSitePlusM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
			
		
			
				
			
			
				
					
					
				
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:commonM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
		
			
		<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:optsPubWebM">
<xsl:apply-templates/>
<xsl:apply-overlays/>
</xsl:template>
			
			
				
			
			
				
			
		
			
			
		
			
			
		
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:optsPubWebM/sp:comments[@sc:refUri]">
<attrRef nm="of_optsPubWebM:comments:" refUri="{@sc:refUri}"/>
</xsl:template>
		
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:optsPubWebM/sp:rating[@sc:refUri]">
<attrRef nm="of_optsPubWebM:rating:" refUri="{@sc:refUri}"/>
</xsl:template>
		
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:optsPubWebM/sp:search[@sc:refUri]">
<attrRef nm="of_optsPubWebM:search:" refUri="{@sc:refUri}"/>
</xsl:template>
		
			
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="of:optsPubWebM/sp:stats[@sc:refUri]">
<attrRef nm="of_optsPubWebM:stats:" refUri="{@sc:refUri}"/>
</xsl:template>
		

</xsl:stylesheet>